//This file is generated by TAU's proxygenerator 
// The command line used to generate it was: 
// ./tau_pg -c integrators::ccaports::Integrator -t integrators.ccaports.Integrator -n IntegratorMeasurementProxy -p IntegratorPort -d MidpointIntegrator_CCA.pdb -h ports/Integrator_CCA.h 

#include <iostream> 
#include "cca.h" 
#include "Measurement_CCA.h" 
#include "ports/Integrator_CCA.h" 
#include <unistd.h> 
using namespace std; 

#define TAU_COMP_NAME1 integrators::ccaports::Integrator
#define TAU_COMP_NAME2 "integrators.ccaports.Integrator" 
namespace TAU1 
 { 
  namespace TAU2
  { 
    class IntegratorMeasurementProxy : public virtual TAU_COMP_NAME1, 
      public virtual classic::gov::cca::Component 
      { 
        public:  
		 
	IntegratorMeasurementProxy();
	~IntegratorMeasurementProxy(void);
	double	integrate(double lowBound,double upBound,int count);
	virtual void setServices(classic::gov::cca::Services *services); 
	private: 
	  classic::gov::cca::Services *frameworkServices; 
	  performance::Timer* tautimers[1];
      }; 
IntegratorMeasurementProxy::IntegratorMeasurementProxy() {
  for (int i=0; i<1; i++) {
    tautimers[i] = NULL;
  }
}

IntegratorMeasurementProxy::~IntegratorMeasurementProxy(void)
{
}
double IntegratorMeasurementProxy::integrate( double lowBound , double upBound , int count )
{
  classic::gov::cca::Port *port; 
  // Get proxy port 
  TAU_COMP_NAME1 *proxy; 
  port = frameworkServices->getPort("IntegratorPortUse");
  if (port) 
    proxy = dynamic_cast < TAU_COMP_NAME1 * > (port);  
  if (proxy == 0) 
  { 
    cerr <<"Connected to something other than a(n) IntegratorPort port"<< endl; 
  }

  if (tautimers[0] == NULL) { 
    // Get a Measurement port 
    port = frameworkServices->getPort("MeasurementPort");
    performance::ccaports::Measurement *measurement; 
    if (port) 
      measurement = dynamic_cast < performance::ccaports::Measurement * >(port); 
    if (measurement == 0) { 
      std::cerr <<"Measurement port not connected properly"<<endl; 
    } 
    classic::gov::cca::ComponentID *cid = frameworkServices->getComponentID(); 
    string componentName = cid->toString(); 
    tautimers[0] = measurement->createTimer(componentName 
            + string("::") + string("integrate"), string("double (double, double, int)"));
    frameworkServices->releasePort("MeasurementPort");
  }

  tautimers[0]->start(); 
  double result = proxy->integrate(lowBound,upBound,count); 

  tautimers[0]->stop();
  // Releasing ports  
 

  frameworkServices->releasePort("IntegratorPortUse"); 
  return result; 
}
void IntegratorMeasurementProxy::setServices (classic::gov::cca::Services *services)
{
  if (services != 0) 
  {  
    frameworkServices = services; 
    classic::gov::cca::PortInfo * portInfo =  
      frameworkServices->createPortInfo ("IntegratorPortProvide", TAU_COMP_NAME2, 0); 
    if (portInfo != 0) 
      frameworkServices->addProvidesPort(this, portInfo); 

    portInfo = frameworkServices->createPortInfo("IntegratorPortUse", TAU_COMP_NAME2, 0); 
    frameworkServices->registerUsesPort(portInfo); 
    // Use a Measurement Port 
    portInfo = frameworkServices->createPortInfo("MeasurementPort",
      "performance.ccaports.Measurement", 0); 
    frameworkServices->registerUsesPort(portInfo); 
  }
  else 
  { 
    // Close down services if not closed already 
    if (frameworkServices != 0) 
      frameworkServices->removeProvidesPort("IntegratorPortProvide"); 
    frameworkServices = 0; 
  } /* end of if */
} /* end of setServices */
  } /* namespace TAU2 */
} /* namespace TAU1 */


/* C wrappers for the component */
extern "C" 
{ 
  classic::gov::cca::Component *createIntegratorMeasurementProxy() {
    classic::gov::cca::Component *wrapper; 
    TAU1::TAU2::IntegratorMeasurementProxy * component; 
    component = new TAU1::TAU2::IntegratorMeasurementProxy();  
    wrapper = dynamic_cast < classic::gov::cca::Component *> (component); 
    return wrapper; 
  } 

  char **getComponentList() {
    static char *list[2]; 
    list[0] = "createIntegratorMeasurementProxy IntegratorMeasurementProxy"; 
    list[1] = 0; 
    return list; 
  } 
}; /* extern C */ 
