// 
// File:          sample_Driver_Impl.cxx
// Symbol:        sample.Driver-v1.0
// Symbol Type:   class
// Babel Version: 1.4.0 (Revision: 6864 release-1-4-0-branch)
// Description:   Server-side implementation for sample.Driver
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// 
#include "sample_Driver_Impl.hxx"

// 
// Includes for all method dependencies.
// 
#ifndef included_gov_cca_CCAException_hxx
#include "gov_cca_CCAException.hxx"
#endif
#ifndef included_gov_cca_Services_hxx
#include "gov_cca_Services.hxx"
#endif
#ifndef included_sidl_BaseInterface_hxx
#include "sidl_BaseInterface.hxx"
#endif
#ifndef included_sidl_ClassInfo_hxx
#include "sidl_ClassInfo.hxx"
#endif
#ifndef included_sidl_RuntimeException_hxx
#include "sidl_RuntimeException.hxx"
#endif
#ifndef included_sidl_NotImplementedException_hxx
#include "sidl_NotImplementedException.hxx"
#endif
// DO-NOT-DELETE splicer.begin(sample.Driver._includes)
#include <Performance_Measurement.hxx>
#include <iostream>
#include <unistd.h>
#include <sample_Driver_Impl.hxx>
// DO-NOT-DELETE splicer.end(sample.Driver._includes)

// special constructor, used for data wrapping(required).  Do not put code here unless you really know what you're doing!
sample::Driver_impl::Driver_impl() : StubBase(reinterpret_cast< void*>(
  ::sample::Driver::_wrapObj(reinterpret_cast< void*>(this))),false) , _wrapped(
  true){ 
  // DO-NOT-DELETE splicer.begin(sample.Driver._ctor2)
  // Insert-Code-Here {sample.Driver._ctor2} (ctor2)
  // DO-NOT-DELETE splicer.end(sample.Driver._ctor2)
}

// user defined constructor
void sample::Driver_impl::_ctor() {
  // DO-NOT-DELETE splicer.begin(sample.Driver._ctor)
  // Insert-Code-Here {sample.Driver._ctor} (constructor)
  // DO-NOT-DELETE splicer.end(sample.Driver._ctor)
}

// user defined destructor
void sample::Driver_impl::_dtor() {
  // DO-NOT-DELETE splicer.begin(sample.Driver._dtor)
  // Insert-Code-Here {sample.Driver._dtor} (destructor)
  // DO-NOT-DELETE splicer.end(sample.Driver._dtor)
}

// static class initializer
void sample::Driver_impl::_load() {
  // DO-NOT-DELETE splicer.begin(sample.Driver._load)
  // Insert-Code-Here {sample.Driver._load} (class initialization)
  // DO-NOT-DELETE splicer.end(sample.Driver._load)
}

// user defined static methods: (none)

// user defined non-static methods:
/**
 *  
 * Execute some encapsulated functionality on the component. 
 * Return 0 if ok, -1 if internal error but component may be 
 * used further, and -2 if error so severe that component cannot
 * be further used safely.
 */
int32_t
sample::Driver_impl::go_impl () 

{
  // DO-NOT-DELETE splicer.begin(sample.Driver.go)
  ::gov::cca::Port port;

  port = frameworkServices.getPort ("MeasurementPort");
  if (port._is_nil()) {
    std::cerr << "MeasurementPort is not connected" << std::endl;
    return -1;
  }

  Performance::Measurement measurement = ::babel_cast< Performance::Measurement >(port);


  ::Performance::ContextEvent contextEvent = measurement.createContextEventWithName("Context Event");
  
  
  // Create and start a timer
  static ::Performance::Timer tautimer = 
    measurement.createTimerWithNameTypeGroup("go", "int32_t ()",
					     "TAU_GROUP_CCA");
  tautimer.start();
  
  for (int i = 0; i < 4; i++) {
    
    std::ostringstream os;
    os << "Iteration " << i;
    std::string phaseName = os.str();

    // Create and start a phase
    ::Performance::Phase phase = measurement.createPhaseWithName(phaseName);
    phase.start();
    
    

    // Configure TAU with -PROFILEPARAM to use the following
    
    static ::Performance::Timer paramTimer = 
      measurement.createTimerWithNameTypeGroup("param", "", "TAU_GROUP_CCA");
    paramTimer.start();
    paramTimer.setParam1L(42,"parameter");
    paramTimer.stop();
    
    paramTimer.start();
    paramTimer.setParam1L(i,"parameter");
    paramTimer.stop();

    // Create a memory tracker and start interrupt driven memory tracking
    ::Performance::MemoryTracker tracker = 
	measurement.createMemoryTracker();
    tracker.enableInterruptTracking();
    

    contextEvent.trigger(i);
    
    sleep(i);
    
    // Manually track memory here
    tracker.trackHere();
    
    phase.stop();
  }
  

  // Create a query interface
  ::Performance::Query query = measurement.createQuery();

  // Get the event names
  ::sidl::array< ::std::string> eventNames = query.getEventNames();


  ::sidl::array<int32_t> numSamples;
  ::sidl::array<double> max, min, mean, sumSqr;

  // Get the event data
  query.getEventData(eventNames, numSamples, max, min, mean, sumSqr);

  int numEvents = eventNames.upper(0) - eventNames.lower(0) + 1;
  for (int i = 0; i < numEvents; i++) {
    std::cout << "User Event: " << eventNames.get(i) << std::endl;
    std::cout << "Number of Samples: " << numSamples.get(i) << std::endl;
    std::cout << "Maximum Value: " << max.get(i) << std::endl;
    std::cout << "Minimim Value: " << min.get(i) << std::endl;
    std::cout << "Mean Value: " << mean.get(i) << std::endl;
    std::cout << "Sum Squared: " << sumSqr.get(i) << std::endl << std::endl;

  }

  tautimer.stop();

  frameworkServices.releasePort("MeasurementPort");

  return 0;
  // DO-NOT-DELETE splicer.end(sample.Driver.go)
}

/**
 *  Starts up a component presence in the calling framework.
 * @param services the component instance's handle on the framework world.
 * Contracts concerning services and setServices:
 * 
 * The component interaction with the CCA framework
 * and Ports begins on the call to setServices by the framework.
 * 
 * This function is called exactly once for each instance created
 * by the framework.
 * 
 * The argument services will never be nil/null.
 * 
 * Those uses ports which are automatically connected by the framework
 * (so-called service-ports) may be obtained via getPort during
 * setServices.
 */
void
sample::Driver_impl::setServices_impl (
  /* in */::gov::cca::Services& services ) 
// throws:
//    ::gov::cca::CCAException
//    ::sidl::RuntimeException
{
  // DO-NOT-DELETE splicer.begin(sample.Driver.setServices)

  frameworkServices = services;

  gov::cca::TypeMap tm = frameworkServices.createTypeMap();
    
  frameworkServices.addProvidesPort (*this,
                                       "Go",
                                       "gov.cca.ports.GoPort", tm);
    
  frameworkServices.registerUsesPort ("MeasurementPort",
	                 	      "Performance.Measurement", tm);
  
  // DO-NOT-DELETE splicer.end(sample.Driver.setServices)
}


// DO-NOT-DELETE splicer.begin(sample.Driver._misc)
// Insert-Code-Here {sample.Driver._misc} (miscellaneous code)
// DO-NOT-DELETE splicer.end(sample.Driver._misc)

